/*
 * CigarTabletFitnessFunction.java
 *
 * Created on 25 de julio de 2005, 17:59
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package FitnessFunctions.RealFF;
import geneticalgorithms.ChromosomeRepresentations.RealChromosome;
import geneticalgorithms.ChromosomeRepresentations.Chromosome;
import java.util.Vector;


/**
 *
 * @author carlos
 */
public class CigarTabletFitnessFunction extends RealFitnessFunction{
    
    /** Creates a new instance of CigarTabletFitnessFunction */
    public CigarTabletFitnessFunction(double minGenValue, double maxGenValue) {
        super(minGenValue, maxGenValue);
    }
    
    public double compare(double f1, double f2){
        return (f2 - f1);
    }
    
    public double getWorstFitness(){
        return Double.POSITIVE_INFINITY;
    }
    
    public double fitness(Chromosome c, Vector remainder){
        return (this.fitness(c));
    }
    
    public double fitness(Chromosome c){
        
        this.incrementNumEvaluations();
        RealChromosome rc = (RealChromosome) c;
        int dimensionLess1 = rc.getNumGenes() - 1;
        int i;
        double firstGen = rc.getGen(0);
        double lastGen = rc.getGen(dimensionLess1);
        double sum = 0;
        double currentGen;
        
        for (i = 1; i < dimensionLess1; i++){
            currentGen = rc.getGen(i);
            sum += (currentGen * currentGen);
        }
        
        sum = 1e4 * sum + 1e8 * lastGen * lastGen + firstGen * firstGen;
        return sum;
    }

    /** returns a name for the funcion*/
    public String getName(){
        return "CigarTablet";
    }
    
    /** return the dimension of the function*/
    public int getDimension(){
        return -1;
    }
}
