/*
 * ComposedGriRos.java
 *
 * Created on 25 de julio de 2005, 20:09
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package FitnessFunctions.RealFF;
import geneticalgorithms.ChromosomeRepresentations.Chromosome;
import geneticalgorithms.ChromosomeRepresentations.RealChromosome;
import java.util.Vector;


/**
 *
 * @author carlos
 */
public class ComposedGriRos extends RealFitnessFunction{
    
    RealFitnessFunction griewankFunction;
    RealFitnessFunction rosenbrockFunction;
    
    /** Creates a new instance of ComposedGriRos */
    public ComposedGriRos(double minGenValue, double maxGenValue) {
        super(minGenValue, maxGenValue);
        
        //TODO he supuesto que d = 4000
        griewankFunction = new GriewangkFitnessFunction(4000, minGenValue, maxGenValue);
        rosenbrockFunction = new RosenbrockFitnessFunction(minGenValue, maxGenValue);
    }
    
    public double compare(double f1, double f2){
        return (f2 - f1);
    }
    
    public double getWorstFitness(){
        return Double.POSITIVE_INFINITY;
    }
    
    public double fitness(Chromosome c){
        
        this.incrementNumEvaluations();
        RealChromosome rc = (RealChromosome) c;
        int dimension = rc.getNumGenes();
        int i;
        double sum = 0;
        RealChromosome rcaux1 = new RealChromosome(2);
        RealChromosome rcaux2 = new RealChromosome(1);
        
        for (i = 1; i < dimension; i++){
            rcaux1.setGen(rc.getGen(i - 1), 0);
            rcaux1.setGen(rc.getGen(i), 1);
            rcaux2.setGen(this.rosenbrockFunction.fitness(rcaux1), 0);
            sum += this.griewankFunction.fitness(rcaux2);
        }
        
        rcaux1.setGen(rc.getGen(i - 1), 0);
        rcaux1.setGen(rc.getGen(0), 1);
        rcaux2.setGen(this.rosenbrockFunction.fitness(rcaux1), 0);
        sum += this.griewankFunction.fitness(rcaux2);
        return sum;
    }
    
    public double fitness(Chromosome c, Vector remainder){
        return (this.fitness(c));
    }
    
    /** returns a name for the funcion*/
    public String getName(){
        return "F8F2";
    }
    
    /** return the dimension of the function*/
    public int getDimension(){
        return -1;
    }
}
