/*
 * EF10.java
 *
 * Created on 25 de julio de 2005, 20:00
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package FitnessFunctions.RealFF;
import geneticalgorithms.ChromosomeRepresentations.Chromosome;
import geneticalgorithms.ChromosomeRepresentations.RealChromosome;
import java.util.Vector;


/**
 *
 * @author carlos
 */
public class EF10 extends RealFitnessFunction{
    
    /** Creates a new instance of EF10 */
    public EF10(double minGenValue, double maxGenValue) {
        super(minGenValue, maxGenValue);
    }
    
    public double compare(double f1, double f2){
        return (f2 - f1);
    }
    
    public double getWorstFitness(){
        return Double.POSITIVE_INFINITY;
    }
    
    public double fitness(Chromosome c){
        
        this.incrementNumEvaluations();
        RealChromosome rc = (RealChromosome) c;
        int dimension = rc.getNumGenes();
        int i;
        double sum = 0;
        double currentGen, nextGen;
        
        currentGen = rc.getGen(0);
        
        for (i = 1; i < dimension; i++){
            nextGen = rc.getGen(i);
            sum += this.f10(currentGen, nextGen);
            currentGen = nextGen;
        }
        
        sum += this.f10(currentGen, rc.getGen(0));
        return sum;
    }
    
    public double fitness(Chromosome c, Vector remainder){
        
        return this.fitness(c);
    }
    
    private double f10(double x, double y){
        
        double aux1, aux2;
        
        aux1 = x * x + y * y;
        aux2 = Math.sin(50 * Math.pow(aux1, 0.1)) + 1;
        
        return (Math.pow(aux1, 0.25) * aux2);
    }
    
    /** returns a name for the funcion*/
    public String getName(){
        return "EF10";
    }
    
    /** return the dimension of the function*/
    public int getDimension(){
        return -1;
    }
}
