package FitnessFunctions.RealFF;

import java.util.*;
import geneticalgorithms.ChromosomeRepresentations.Chromosome;
import geneticalgorithms.ChromosomeRepresentations.RealChromosome;


/**
 * <p>Título: Genetic Algorithms</p>
 * <p>Descripción: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Empresa: </p>
 * @author Carlos García Martínez
 * @version 1.0
 */

public class GriewangkFitnessFunction extends RealFitnessFunction {
    
    protected double d;
    
    public GriewangkFitnessFunction(double d, double minValue, double maxValue) {
        super(minValue, maxValue);
        this.d = d;
    }
    
    public double fitness(Chromosome c) {
        this.incrementNumEvaluations();
        RealChromosome rc = (RealChromosome) c;
        int numGenes = rc.getNumGenes();
        double sum1 = 0.0, sum2 = 1.0, auxVal;
        
        for (int i = 0; i < numGenes; i++){
            double currentGen = rc.getGen(i);
            sum1 += (currentGen * currentGen);
            auxVal = Math.sqrt((double) (i + 1));
            sum2 *= Math.cos(currentGen / auxVal);
        }
        
        return (sum1 / this.d - sum2 + 1.0);
    }
    
    public double compare(double f1, double f2) {
        return (f2 - f1);
    }
    
    public double getWorstFitness(){
        return Double.POSITIVE_INFINITY;
    }
    
    public double fitness(Chromosome c, Vector remainder) {
        return (this.fitness(c));
    }
    
    /** returns a name for the funcion*/
    public String getName(){
        return "Gri";
    }
    
    /** return the dimension of the function*/
    public int getDimension(){
        return -1;
    }
}