package FitnessFunctions.RealFF;

import java.util.*;
import geneticalgorithms.ChromosomeRepresentations.Chromosome;
import geneticalgorithms.ChromosomeRepresentations.RealChromosome;


/**
 * <p>Título: Genetic Algorithms</p>
 * <p>Descripción: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Empresa: </p>
 * @author Carlos García Martínez
 * @version 1.0
 */

public class LinearEquationsSystemFitnessFunction extends RealFitnessFunction {
    
    protected double [][]A = {{5.0, 4.0, 5.0, 2.0, 9.0, 5.0, 4.0, 2.0, 3.0, 1.0},
    {9.0, 7.0, 1.0, 1.0, 7.0, 2.0, 2.0, 6.0, 6.0, 9.0},
    {3.0, 1.0, 8.0, 6.0, 9.0, 7.0, 4.0, 2.0, 1.0, 6.0},
    {8.0, 3.0, 7.0, 3.0, 7.0, 5.0, 3.0, 9.0, 9.0, 5.0},
    {9.0, 5.0, 1.0, 6.0, 3.0, 4.0, 2.0, 3.0, 3.0, 9.0},
    {1.0, 2.0, 3.0, 1.0, 7.0, 6.0, 6.0, 3.0, 3.0, 3.0},
    {1.0, 5.0, 7.0, 8.0, 1.0, 4.0, 7.0, 8.0, 4.0, 8.0},
    {9.0, 3.0, 8.0, 6.0, 3.0, 4.0, 7.0, 1.0, 8.0, 1.0},
    {8.0, 2.0, 8.0, 5.0, 3.0, 8.0, 7.0, 2.0, 7.0, 5.0},
    {2.0, 1.0, 2.0, 2.0, 9.0, 8.0, 7.0, 4.0, 4.0, 1.0}};
    protected double []B = {40.0, 50.0, 47.0, 59.0, 45.0, 35.0, 53.0, 50.0, 55.0, 40.0};
    
    public LinearEquationsSystemFitnessFunction(double minValue, double maxValue) {
        super(minValue, maxValue);
    /*A = new double[10][10];
    B = new double[10];
     
A[0][0]=5.0;A[0][1]=4.0;A[0][2]=5.0;A[0][3]=2.0;A[0][4]=9.0;A[0][5]=5.0;A[0][6]=4.0;A[0][7]=2.0;A[0][8]=3.0;A[0][9]=1.0;
A[1][0]=9.0;A[1][1]=7.0;A[1][2]=1.0;A[1][3]=1.0;A[1][4]=7.0;A[1][5]=2.0;A[1][6]=2.0;A[1][7]=6.0;A[1][8]=6.0;A[1][9]=9.0;
A[2][0]=3.0;A[2][1]=1.0;A[2][2]=8.0;A[2][3]=6.0;A[2][4]=9.0;A[2][5]=7.0;A[2][6]=4.0;A[2][7]=2.0;A[2][8]=1.0;A[2][9]=6.0;
A[3][0]=8.0;A[3][1]=3.0;A[3][2]=7.0;A[3][3]=3.0;A[3][4]=7.0;A[3][5]=5.0;A[3][6]=3.0;A[3][7]=9.0;A[3][8]=9.0;A[3][9]=5.0;
A[4][0]=9.0;A[4][1]=5.0;A[4][2]=1.0;A[4][3]=6.0;A[4][4]=3.0;A[4][5]=4.0;A[4][6]=2.0;A[4][7]=3.0;A[4][8]=3.0;A[4][9]=9.0;
A[5][0]=1.0;A[5][1]=2.0;A[5][2]=3.0;A[5][3]=1.0;A[5][4]=7.0;A[5][5]=6.0;A[5][6]=6.0;A[5][7]=3.0;A[5][8]=3.0;A[5][9]=3.0;
A[6][0]=1.0;A[6][1]=5.0;A[6][2]=7.0;A[6][3]=8.0;A[6][4]=1.0;A[6][5]=4.0;A[6][6]=7.0;A[6][7]=8.0;A[6][8]=4.0;A[6][9]=8.0;
A[7][0]=9.0;A[7][1]=3.0;A[7][2]=8.0;A[7][3]=6.0;A[7][4]=3.0;A[7][5]=4.0;A[7][6]=7.0;A[7][7]=1.0;A[7][8]=8.0;A[7][9]=1.0;
A[8][0]=8.0;A[8][1]=2.0;A[8][2]=8.0;A[8][3]=5.0;A[8][4]=3.0;A[8][5]=8.0;A[8][6]=7.0;A[8][7]=2.0;A[8][8]=7.0;A[8][9]=5.0;
A[9][0]=2.0;A[9][1]=1.0;A[9][2]=2.0;A[9][3]=2.0;A[9][4]=9.0;A[9][5]=8.0;A[9][6]=7.0;A[9][7]=4.0;A[9][8]=4.0;A[9][9]=1.0;
     
B[0]=40.0; B[1]=50.0; B[2]=47.0; B[3]=59.0; B[4]=45.0; B[5]=35.0; B[6]=53.0; B[7]=50.0; B[8]=55.0; B[9]=40.0;*/
        
    }
    
    public double fitness(Chromosome c) {
        this.incrementNumEvaluations();
        RealChromosome rc = (RealChromosome) c;
        int numGenes = rc.getNumGenes();
        double sum = 0.0, aux = 0.0;
        int i, j;
        
        for (i = 0; i < numGenes; i++){
            
            aux = 0.0;
            
            for (j = 0; j < numGenes; j++){
                double currentGen = rc.getGen(j);
                aux += (this.A[i][j] * currentGen);
            }
            
            if (aux > this.B[i])
                sum += aux - this.B[i];
            else
                sum += this.B[i] - aux;
        }
        
        return sum;
    }
    
    public double compare(double f1, double f2) {
        return (f2 - f1);
    }
    
    public double getWorstFitness(){
        return Double.POSITIVE_INFINITY;
    }
    
    public double fitness(Chromosome c, Vector remainder) {
        return (this.fitness(c));
    }
    
    /** returns a name for the funcion*/
    public String getName(){
        return "Psle";
    }
    
    /** return the dimension of the function*/
    public int getDimension(){
        return -1;
    }
}