/*
 * QuarticNoiseFitnessFunction.java
 *
 * Created on 25 de julio de 2005, 18:36
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package FitnessFunctions.RealFF;
import geneticalgorithms.ChromosomeRepresentations.Chromosome;
import geneticalgorithms.ChromosomeRepresentations.RealChromosome;
import others.Random;
import java.util.Vector;


/**
 *
 * @author carlos
 */
public class QuarticNoiseFitnessFunction extends RealFitnessFunction{
    
    /** Creates a new instance of QuarticNoiseFitnessFunction */
    public QuarticNoiseFitnessFunction(double minGenValue, double maxGenValue) {
        super(minGenValue, maxGenValue);
    }
    
    public double compare(double f1, double f2){
        return (f2-f1);
    }
    
    public double getWorstFitness(){
        return Double.POSITIVE_INFINITY;
    }
    
    public double fitness(Chromosome c){
        
        this.incrementNumEvaluations();
        RealChromosome rc = (RealChromosome) c;
        int dimension = rc.getNumGenes();
        int i;
        double sum = 0;
        double currentGen;
        
        for (i = 0; i < dimension; i++){
            currentGen = rc.getGen(i);
            sum += (i + 1) * Math.pow(currentGen, 4);
        }
        
        sum += Random.Rand();
        return sum;
    }
    
    public double fitness(Chromosome c, Vector remainder){
        return (this.fitness(c));
    }
    
    /** returns a name for the funcion*/
    public String getName(){
        return "QNoise";
    }
    
    /** return the dimension of the function*/
    public int getDimension(){
        return -1;
    }
}
