package FitnessFunctions.RealFF;

import java.util.*;
import geneticalgorithms.ChromosomeRepresentations.Chromosome;
import geneticalgorithms.ChromosomeRepresentations.RealChromosome;


/**
 * <p>Título: Genetic Algorithms</p>
 * <p>Descripción: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Empresa: </p>
 * @author Carlos García Martínez
 * @version 1.0
 */

public class RastriginFitnessFunction extends RealFitnessFunction {
    
    protected double a;
    protected double omega;
    
    public RastriginFitnessFunction(double a, double omega, double minValue, double maxValue) {
        super(minValue, maxValue);
        this.a = a;
        this.omega = omega;
    }
    
    public double fitness(Chromosome c) {
        this.incrementNumEvaluations();
        RealChromosome rc = (RealChromosome) c;
        int numGenes = rc.getNumGenes();
        double sum = 0;
        
        for (int i = 0; i < numGenes; i++){
            double currentGen = rc.getGen(i);
            sum += (currentGen * currentGen - this.a * Math.cos(this.omega * currentGen));
        }
        
        return (this.a * numGenes + sum);
    }
    
    public double compare(double f1, double f2) {
        return (f2 - f1);
    }
    
    public double getWorstFitness(){
        return Double.POSITIVE_INFINITY;
    }
    
    public double fitness(Chromosome c, Vector remainder) {
        return (this.fitness(c));
    }
    
    /** returns a name for the funcion*/
    public String getName(){
        return "Ras";
    }
    
    /** return the dimension of the function*/
    public int getDimension(){
        return -1;
    }
}