package FitnessFunctions.RealFF;

import java.util.*;
import geneticalgorithms.ChromosomeRepresentations.Chromosome;
import geneticalgorithms.ChromosomeRepresentations.RealChromosome;


/**
 * <p>Título: Genetic Algorithms</p>
 * <p>Descripción: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Empresa: </p>
 * @author Carlos García Martínez
 * @version 1.0
 */

public class RosenbrockFitnessFunction extends RealFitnessFunction {
    
    public RosenbrockFitnessFunction(double minValue, double maxValue) {
        super(minValue, maxValue);
    }
    
    public double fitness(Chromosome c) {
        this.incrementNumEvaluations();
        RealChromosome rc = (RealChromosome) c;
        int numGenes = rc.getNumGenes();
        double sum = 0;
        double aux1, aux2;
        double nextGen = rc.getGen(0);
        
        for (int i = 1; i < numGenes; i++){
            double currentGen = nextGen;
            nextGen = rc.getGen(i);
            aux1 = nextGen - currentGen * currentGen;
            aux2 = currentGen - 1;
            sum += (100 * aux1 * aux1 + aux2 * aux2);
        }
        
        return sum;
    }
    
    public double compare(double f1, double f2) {
        return (f2 - f1);
    }
    
    public double getWorstFitness(){
        return Double.POSITIVE_INFINITY;
    }
    
    public double fitness(Chromosome c, Vector remainder) {
        return (this.fitness(c));
    }
    
    /** returns a name for the funcion*/
    public String getName(){
        return "Ros";
    }
    
    /** return the dimension of the function*/
    public int getDimension(){
        return -1;
    }
}