/*
 * ScaledRastriginFitnessFunction.java
 *
 * Created on 25 de julio de 2005, 19:35
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package FitnessFunctions.RealFF;
import geneticalgorithms.ChromosomeRepresentations.Chromosome;
import geneticalgorithms.ChromosomeRepresentations.RealChromosome;
import java.util.Vector;


/**
 *
 * @author carlos
 */
public class ScaledRastriginFitnessFunction extends RealFitnessFunction{
    
    RealFitnessFunction rastriginFunction;
    
    /** Creates a new instance of ScaledRastriginFitnessFunction */
    public ScaledRastriginFitnessFunction(double minGenValue, double maxGenValue) {
        
        super(minGenValue, maxGenValue);
        rastriginFunction = new RastriginFitnessFunction(10, 2 * Math.PI, minGenValue, maxGenValue);
    }
    
    public double compare(double f1, double f2){
        return (f2 - f1);
    }
    
    public double getWorstFitness(){
        return Double.POSITIVE_INFINITY;
    }
    
    public double fitness(Chromosome c){
        
        this.incrementNumEvaluations();
        RealChromosome rc = (RealChromosome) c.clone();
        int dimension = rc.getNumGenes();
        int i;
        
        for (i = 0; i < dimension; i++){
            rc.setGen(rc.getGen(i) * Math.pow(10, i / (dimension - 1)), i);
        }
        
        return (rastriginFunction.fitness(rc));
    }
    
    public double fitness(Chromosome c, Vector remainder){
        
        return (this.fitness(c));
    }
    
    /** returns a name for the funcion*/
    public String getName(){
        return "SRas";
    }
    
    /** return the dimension of the function*/
    public int getDimension(){
        return -1;
    }
}
