/*
 * SchafferFitnessFunction.java
 *
 * Created on 25 de julio de 2005, 20:53
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package FitnessFunctions.RealFF;
import geneticalgorithms.ChromosomeRepresentations.RealChromosome;
import geneticalgorithms.ChromosomeRepresentations.Chromosome;
import java.util.Vector;


/**
 *
 * @author carlos
 */
public class SchafferFitnessFunction extends RealFitnessFunction{
    
    /** Creates a new instance of SchafferFitnessFunction */
    public SchafferFitnessFunction(double minGenValue, double maxGenValue) {
        super(minGenValue, maxGenValue);
    }
    
    public double compare(double f1, double f2){
        return (f2 - f1);
    }
    
    public double getWorstFitness(){
        return Double.POSITIVE_INFINITY;
    }
    
    public double fitness(Chromosome c){
        
        this.incrementNumEvaluations();
        RealChromosome rc = (RealChromosome) c;
        int dimension = rc.getNumGenes();
        int i;
        double sum, aux, aux2;
        double currentGen, nextGen;
        
        sum = 0;
        currentGen = rc.getGen(0);
        currentGen = currentGen * currentGen;
        
        for (i = 1; i < dimension; i++){
            nextGen = rc.getGen(i);
            nextGen = nextGen * nextGen;
            aux = currentGen + nextGen;
            currentGen = nextGen;
            aux2 = Math.sin(50 * Math.pow(aux, 0.1)) + 1;
            
            sum += Math.pow(aux, 0.25) * aux2 * aux2;
        }
        
        return sum;
    }
    
    public double fitness(Chromosome c, Vector remainder){
        return (this.fitness(c));
    }
    
    /** returns a name for the funcion*/
    public String getName(){
        return "Schaffer";
    }
    
    /** return the dimension of the function*/
    public int getDimension(){
        return -1;
    }
}
