package FitnessFunctions.RealFF;

import java.util.*;
import geneticalgorithms.ChromosomeRepresentations.Chromosome;
import geneticalgorithms.ChromosomeRepresentations.RealChromosome;


/**
 * <p>Título: Genetic Algorithms</p>
 * <p>Descripción: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Empresa: </p>
 * @author Carlos García Martínez
 * @version 1.0
 */

public class Schwefel1_2FitnessFunction extends RealFitnessFunction {
    
    public Schwefel1_2FitnessFunction(double minValue, double maxValue) {
        super(minValue, maxValue);
    }
    
    public double fitness(Chromosome c) {
        this.incrementNumEvaluations();
        RealChromosome rc = (RealChromosome) c;
        int numGenes = rc.getNumGenes();
        int i, j;
        double sum = 0;
        double sum2 = 0;
        
        for (i = 0; i < numGenes; i++){
            sum2 += rc.getGen(i);
            sum += (sum2 * sum2);
        }
        
        return sum;
    }
    public double compare(double f1, double f2) {
        return (f2 - f1);
    }
    
    public double getWorstFitness(){
        return Double.POSITIVE_INFINITY;
    }
    
    
    public double fitness(Chromosome c, Vector remainder) {
        return (this.fitness(c));
    }
    
    /** returns a name for the funcion*/
    public String getName(){
        return "Sch1.2";
    }
    
    /** return the dimension of the function*/
    public int getDimension(){
        return -1;
    }
    
}