/*
 * Schwefel2_21FitnessFunction.java
 *
 * Created on 25 de julio de 2005, 18:23
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package FitnessFunctions.RealFF;
import geneticalgorithms.ChromosomeRepresentations.RealChromosome;
import geneticalgorithms.ChromosomeRepresentations.Chromosome;
import java.util.Vector;


/**
 *
 * @author carlos
 */
public class Schwefel2_21FitnessFunction extends RealFitnessFunction{
    
    /** Creates a new instance of Schwefel2_21FitnessFunction */
    public Schwefel2_21FitnessFunction(double minGenValue, double maxGenValue) {
        super(minGenValue, maxGenValue);
    }
    
    public double compare(double f1, double f2){
        return (f2 - f1);
    }
    
    public double getWorstFitness(){
        return Double.POSITIVE_INFINITY;
    }
    
    public double fitness(Chromosome c){
        
        this.incrementNumEvaluations();
        RealChromosome rc = (RealChromosome) c;
        int dimension = rc.getNumGenes();
        int i;
        double maximo, currentGen;
        
        maximo = Math.abs(rc.getGen(0));
        
        for (i = 1; i < dimension; i++){
            currentGen = Math.abs(rc.getGen(i));
            
            if (currentGen > maximo)
                maximo = currentGen;
        }
        
        return maximo;
    }
    
    public double fitness(Chromosome c, Vector remainder){
        return (this.fitness(c));
    }
    
    /** returns a name for the funcion*/
    public String getName(){
        return "Sch2.21";
    }
    
    /** return the dimension of the function*/
    public int getDimension(){
        return -1;
    }
}
