/*
 * Schwefel2_22FitnessFunction.java
 *
 * Created on 25 de julio de 2005, 18:17
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package FitnessFunctions.RealFF;
import geneticalgorithms.ChromosomeRepresentations.RealChromosome;
import geneticalgorithms.ChromosomeRepresentations.Chromosome;
import java.util.Vector;


/**
 *
 * @author carlos
 */
public class Schwefel2_22FitnessFunction extends RealFitnessFunction {
    
    /** Creates a new instance of Schwefel2_22FitnessFunction */
    public Schwefel2_22FitnessFunction(double minGenValue, double maxGenValue) {
        
        super(minGenValue, maxGenValue);
    }
    
    public double compare(double f1, double f2){
        return (f2 - f1);
    }
    
    public double getWorstFitness(){
        return Double.POSITIVE_INFINITY;
    }
    
    public double fitness(Chromosome c){
        
        this.incrementNumEvaluations();
        RealChromosome rc = (RealChromosome) c;
        int dimension = rc.getNumGenes();
        int i;
        double sum, currentGen, prod;
        
        sum = 0;
        prod = 1;
        
        for (i = 0; i < dimension; i++){
            currentGen = Math.abs(rc.getGen(i));
            sum += currentGen;
            prod *= currentGen;
        }
        
        return (sum + prod);
    }
    
    public double fitness(Chromosome c, Vector remainder){
        return (this.fitness(c));
    }
    
    /** returns a name for the funcion*/
    public String getName(){
        return "Sch2.22";
    }
    
    /** return the dimension of the function*/
    public int getDimension(){
        return -1;
    }
}
