/*
 * Schwefel2_26FitnessFunction.java
 *
 * Created on 25 de julio de 2005, 19:49
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package FitnessFunctions.RealFF;
import geneticalgorithms.ChromosomeRepresentations.RealChromosome;
import geneticalgorithms.ChromosomeRepresentations.Chromosome;
import java.util.Vector;


/**
 *
 * @author carlos
 */
public class Schwefel2_26FitnessFunction extends RealFitnessFunction{
    
    /** Creates a new instance of Schwefel2_26FitnessFunction */
    public Schwefel2_26FitnessFunction(double minGenValue, double maxGenValue) {
        super(minGenValue, maxGenValue);
    }
    
    public double compare(double f1, double f2){
        return (f2 - f1);
    }
    
    public double getWorstFitness(){
        return Double.POSITIVE_INFINITY;
    }
    
    public double fitness(Chromosome c){
        
        this.incrementNumEvaluations();
        RealChromosome rc = (RealChromosome) c;
        double currentGen, sum = 0;
        int dimension = rc.getNumGenes();
        int i;
        
        for (i = 0; i < dimension; i++){
            currentGen = rc.getGen(i);
            sum += currentGen * Math.sin(Math.sqrt(Math.abs(currentGen)));
        }
        
        return (-1) * sum;
    }
    
    public double fitness(Chromosome c, Vector remainder){
        return (this.fitness(c));
    }
    
    /** returns a name for the funcion*/
    public String getName(){
        return "Sch2.26";
    }
    
    /** return the dimension of the function*/
    public int getDimension(){
        return -1;
    }
}
