package FitnessFunctions.RealFF;

import geneticalgorithms.ChromosomeRepresentations.Chromosome;
import geneticalgorithms.ChromosomeRepresentations.RealChromosome;

/**
 * <p>Título: Genetic Algorithms</p>
 * <p>Descripción: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Empresa: </p>
 * @author Carlos García Martínez
 * @version 1.0
 */

import java.util.Vector;


/**
 * This class implements the sphere fitness function: sum x^2.
 */

public class SphereFitnessFunction extends RealFitnessFunction {
    
    public SphereFitnessFunction(double minValue, double maxValue) {
        super(minValue, maxValue, 0, maxValue * maxValue);
    }
    
    // returns the fitness value of a chromosome
    // EL CHROMOSOME C DEBE SER UN OBJETO VÁLIDO DE LA CLASE REALCHROMOSOME
    public double fitness(Chromosome c){
        this.incrementNumEvaluations();
        RealChromosome rc = (RealChromosome) c;
        int numGenes = rc.getNumGenes();
        double sum = 0;
        
        for (int i = 0; i < numGenes; i++){
            double currentGen = rc.getGen(i);
            sum += (currentGen * currentGen);
        }
        
        return sum;
    }
    
    public double fitness(Chromosome c, Vector remainder){
        return (this.fitness(c));
    }
    
    /** This function returns a number greater than 0 if fitness f1 is better than f2,
          -1 if c2 es better than c1, and 0 if both are equivalent. */
    public double compare(double f1, double f2){
        return (f2 - f1);
    }
    
    public double getWorstFitness(){
        return Double.POSITIVE_INFINITY;
    }
    
    /** returns a name for the funcion*/
    public String getName(){
        return "sph";
    }
    
    /** return the dimension of the function*/
    public int getDimension(){
        return -1;
    }
}