package geneticalgorithms.ChromosomeRepresentations;

/**
 * <p>Título: Genetic Algorithms</p>
 * <p>Descripción: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Empresa: </p>
 * @author Carlos García Martínez
 * @version 1.0
 */

/**
 * This class implements the chromosome which represent solutions for real coding problems.
 */

public class RealChromosome extends Chromosome {
  
  // This vector keep the variables in the domain space of the problem.
  protected double []genes;
  
  /** This variable stores the size of the vector genes. */
  protected int numGenes;
  
  // class constructor
  public RealChromosome(int numGenes){
    this.numGenes = numGenes;
    this.genes = new double[numGenes];
  }
  
  // function clone
  public Object clone(){
    
    int i;
    
    RealChromosome clon = new RealChromosome(this.numGenes);
    
    for (i = 0; i < numGenes; i++)
      clon.setGen(this.getGen(i), i);
    
    clon.setCurrentFitness(this.getCurrentFitness());
    
    return clon;
  }
  
  // returns the value of numGenes
  public int getNumGenes(){
    return numGenes;
  }
  
  /** returns the value of the index-th gen. */
  public double getGen(int index){
    return (this.genes[index]);
  }
  
  public double[] getGenes(){
    return (this.genes);
  }
  
  // set the index-th gen to an specific value
  public double setGen(double newValue, int index){
    return (this.genes[index] = newValue);
  }
  
  /**
   * Copies aChromosome in this.
   * @param aChromosome
   */
  public void copy(Chromosome aChromosome){
    
    int i;
    RealChromosome rc = (RealChromosome) aChromosome;
    
    this.currentFitness = rc.currentFitness;
    
    if (this.numGenes != rc.numGenes){
      this.numGenes = rc.numGenes;
      this.genes = new double[this.numGenes];
    }
    
    for (i = 0; i < numGenes; i++)
      this.genes[i] = rc.genes[i];
  }
  
}