package geneticalgorithms.ChromosomeRepresentations;

/**
 * <p>Título: Genetic Algorithms</p>
 * <p>Descripción: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Empresa: </p>
 * @author Carlos García Martínez
 * @version 1.0
 */

public class UFSRealChromosome extends RealChromosome implements UFSChromosome {
  
  //! stores the number of offsprings
  int numOffsprings;
  
  public UFSRealChromosome(int numGenes) {
    super(numGenes);
    numOffsprings = 0;
  }
  
  public int getNumOffsprings(){
    return (numOffsprings);
  }
  
  public void incrementNumOffsprings(){
    this.numOffsprings++;
  }
  
  public void resetNumOffsprings(){
    this.numOffsprings = 0;
  }
  
  public Object clone(){
    
    int i;
    
    UFSRealChromosome clon = new UFSRealChromosome(this.numGenes);
    
    for (i = 0; i < numGenes; i++)
      clon.setGen(this.getGen(i), i);
    
    clon.setCurrentFitness(this.getCurrentFitness());
    
    return clon;
  }
  
  /**
   * Copies aChromosome in this.
   * @param aChromosome
   */
  public void copy(Chromosome aChromosome){
    
    int i;
    UFSRealChromosome ufsrc = (UFSRealChromosome) aChromosome;
    
    this.currentFitness = ufsrc.currentFitness;
    this.numOffsprings = ufsrc.numOffsprings;
    
    if (this.numGenes != ufsrc.numGenes){
      this.numGenes = ufsrc.numGenes;
      this.genes = new double[this.numGenes];
    }
    
    for (i = 0; i < numGenes; i++)
      this.genes[i] = ufsrc.genes[i];
  }
}