package geneticalgorithms.ChromosomeSelectors;

import geneticalgorithms.ChromosomeSelectors.ChromosomeSelector;
import geneticalgorithms.ChromosomeRepresentations.Chromosome;

/**
 * <p>Título: Genetic Algorithms</p>
 * <p>Descripción: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Empresa: </p>
 * @author Carlos García Martínez
 * @version 1.0
 */

import java.util.Vector;

/**
 * This class implements the parents selection mechanism in an steady state
 * genetic algorithm. It selects a subset of chromosomes, an returns the positions
 * of them.
 *
 * ATENTION: It can be used to initialise a population from another population.
 * It would perform such as filter.
 */

public class ParentsSelector {
  
  /** Number of chromosomes which must be selected */
  protected int numChromosomes;
  
  /** Selection mechanism used to select every chromosome */
  protected ChromosomeSelector chromosomeSelector;
  
  public ParentsSelector(int numChromosomes, ChromosomeSelector chromosomeSelector) {
    
    this.numChromosomes = numChromosomes;
    this.chromosomeSelector = chromosomeSelector;
  }
  
  public ChromosomeSelector getSelector(){
    return this.chromosomeSelector;
  }
  
  /** This functions return the position of the chromosomes selected to be parents, stored in a list. */
  public void select(Vector selectedPositions, Vector selectedChromosomes, Vector chromosomes){
    
    int i, j, numSelected;
    numSelected = selectedPositions.size();
    Chromosome aChromosome;
    Vector chromosomesNotSelected = new Vector();
    int [] selectedPositionsInt = new int[this.numChromosomes];
    int incremento;
    
    chromosomesNotSelected.addAll(chromosomes);
    
    for (i = 0; i < this.numChromosomes; i++){
      incremento = 0;
      int currentSelected = this.chromosomeSelector.select(chromosomesNotSelected, selectedChromosomes);
      aChromosome = (Chromosome) chromosomesNotSelected.get(currentSelected);
      selectedChromosomes.add(aChromosome);
      chromosomesNotSelected.remove(currentSelected);
      selectedPositionsInt[i] = currentSelected;
      
      //Calcular la posicion real en el vector chromosomnes, que tiene los seleccionados
      for (j = 0; j < i; j++)
        if (currentSelected >= selectedPositionsInt[j])
          incremento++;
      
      selectedPositions.add(new Integer(currentSelected + incremento));
    }
  }
}