package geneticalgorithms.ChromosomeSelectors;

import geneticalgorithms.ChromosomeRepresentations.UFSChromosome;
import java.util.Vector;

/**
 * <p>Título: Genetic Algorithms</p>
 * <p>Descripción: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Empresa: </p>
 * @author Carlos García Martínez
 * @version 1.0
 */

/**This class implements the UFS Selection mechanism. It selects the chromosome with less offsprings associated.
 * Every list it uses must have valid objects of class UFSChromosome.
 *@author Carlos García Martínez
 */

public class UFSChromosomeSelector implements ChromosomeSelector {
  
  public UFSChromosomeSelector() {
  }
  
  /** This functions select a chromosome from the population. It does not take into account the already selected ones.
   * It returns the position of the selected chromosome in the list population.
   * It also increments the number of offspring counter. */
  public int select(Vector population, Vector alreadySelected) {
    
    int i, lessOffspringPosition, numChromosomes;
    
    numChromosomes = population.size();
    UFSChromosome aChromosome = (UFSChromosome) population.get(0);
    int lessOffspring = aChromosome.getNumOffsprings();
    lessOffspringPosition = 0;
    
    for (i = 1; i < numChromosomes; i++){
      aChromosome = (UFSChromosome) population.get(i);
      int currentOffsprings = aChromosome.getNumOffsprings();
      
      if (lessOffspring > currentOffsprings){
        lessOffspring = currentOffsprings;
        lessOffspringPosition = i;
      }
    }
    
    //Increment the number of offsprings
    aChromosome = (UFSChromosome) population.get(lessOffspringPosition);
    aChromosome.incrementNumOffsprings();
    
    return lessOffspringPosition;
  }
}