package geneticalgorithms.Crossovers.RealCrossovers;

import geneticalgorithms.ChromosomeRepresentations.RealChromosome;
import others.Random;
import FitnessFunctions.RealFF.RealFitnessFunction;
import java.util.Vector;
import geneticalgorithms.Crossovers.*;

/**
 * <p>Título: Genetic Algorithms</p>
 * <p>Descripción: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Empresa: </p>
 * @author Carlos García Martínez
 * @version 1.0
 */

public class PBXalphaCrossover implements Crossover {
  
  RealFitnessFunction fitnessFunction;
  
  /** Crossover parameter */
  protected double alpha;
  protected int lambda;
  
  //! Constructor
  public PBXalphaCrossover(double alpha, RealFitnessFunction fitnessFunction){
    this.fitnessFunction = fitnessFunction;
    this.alpha = alpha;
    lambda = 1;
  }
  
  public PBXalphaCrossover(int lambda, double alpha, RealFitnessFunction fitnessFunction){
    this.fitnessFunction = fitnessFunction;
    this.alpha = alpha;
    this.lambda = lambda;
  }
  
  /** This function returns the offspring by crossing the parents. */
  public void cross(Vector offspring, Vector parents) {
    
    RealChromosome firstParent = (RealChromosome) parents.get(0);
    RealChromosome secondParent = (RealChromosome) parents.get(1);
    int numGenes = firstParent.getNumGenes();
    offspring.removeAllElements();
    
    for (int j = 0; j < lambda; j++){
      
      RealChromosome anOffspring = (RealChromosome) firstParent.clone();
      
      for (int i = 0; i < numGenes; i++){
        double difference = Math.abs(firstParent.getGen(i) - secondParent.getGen(i));
        double min = Math.max(fitnessFunction.getMinGenValue(i), firstParent.getGen(i) - difference * this.alpha);
        double max = Math.min(fitnessFunction.getMaxGenValue(i), firstParent.getGen(i) + difference * this.alpha);
        anOffspring.setGen(Random.Randfloat(min, max), i);
      }
      
      offspring.add(anOffspring);
    }
  }
}