package geneticalgorithms.Initializers;

import geneticalgorithms.ChromosomeRepresentations.UFSRealChromosome;
import others.Random;

import java.util.Vector;

/**
 * <p>Título: Genetic Algorithms</p>
 * <p>Descripción: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Empresa: </p>
 * @author Carlos García Martínez
 * @version 1.0
 */

/**
 * This class implements thw uniform skewed initialisation.
 */

public class UniformUFSRealInitializer implements Initializer {
  
  /** Indicates the number of genes in a chromosome. */
  protected int numGenes;
  
  /** Indicates the minimum of the uniform random initialisation for every gen. */
  protected double min;
  
  /** Indicates the maximum of the uniform random initialisation for every gen. */
  protected double max;
  
  public UniformUFSRealInitializer(int numGenes, double min, double max) {
    this.numGenes = numGenes;
    this.min = min;
    this.max = max;
  }
  
  public void initialize(Vector chromosomes, int numChromosomes) {
    
    int i, j;
    
    chromosomes.removeAllElements();
    
    for (i = 0; i < numChromosomes; i++){
      
      UFSRealChromosome aChromosome = new UFSRealChromosome(this.numGenes);
      
      for (j = 0; j < numGenes; j++)
        aChromosome.setGen(Random.Randfloat(this.min, this.max), j);
      
      chromosomes.add(aChromosome);
    }
  }
}