package geneticalgorithms.ReplacementStrategies;

import java.util.Vector;
import geneticalgorithms.Replacers.Replacer;
import geneticalgorithms.GAStructures.GA;
import geneticalgorithms.GAStructures.SCDGA;

/**
 * It works with SCDGA objects, subclass of S3GA
 *
 * <p>Título: Genetic Algorithms</p>
 * <p>Descripción: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Empresa: </p>
 * @author Carlos García Martínez
 * @version 1.0
 */

public class RestrictedThenRemainderStrategy implements ReplacementStrategy {
  
  Replacer femaleReplacer;
  Replacer maleReplacer;
  
  public RestrictedThenRemainderStrategy(Replacer femaleReplacer,
       Replacer maleReplacer) {
    this.femaleReplacer = femaleReplacer;
    this.maleReplacer = maleReplacer;
  }
  
  public void performReplacement(GA ga, Vector positionParents, Vector offspring) {
    
    SCDGA scdga = (SCDGA) ga;
    Vector femalePopulation = scdga.getFemalePopulation();
    Vector malePopulation = scdga.getMalePopulation();
    int Nf = femalePopulation.size();
    int Nm = malePopulation.size();
    
    if (Nf < Nm){
      
      femaleReplacer.replace(femalePopulation, positionParents, offspring);
      maleReplacer.replace(malePopulation, positionParents, offspring);
      
    } else{
      maleReplacer.replace(malePopulation, positionParents, offspring);
      femaleReplacer.replace(femalePopulation, positionParents, offspring);
    }
  }
}