package geneticalgorithms.Replacers;

import FitnessFunctions.FitnessFunction;
import geneticalgorithms.ChromosomeRepresentations.Chromosome;

/**
 * <p>Título: Genetic Algorithms</p>
 * <p>Descripción: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Empresa: </p>
 * @author Carlos García Martínez
 * @version 1.0
 */

import java.util.Vector;

//! This class implements the replace worst strategy

public class ReplaceWorst implements Replacer {
  
  /** This is the fitness function which guides the replacement strategy. */
  protected FitnessFunction fitnessFunction;
  
  public ReplaceWorst(FitnessFunction fitnessFunction) {
    this.fitnessFunction = fitnessFunction;
  }
  
  public boolean replace(Vector population, Vector positionParents, Vector offspring) {
    
    int i, j;
    Chromosome aChromosome;
    double worstFitness;
    int worstChromosomePosition, numOffsprings, sizePopulation;
    Chromosome anOffspring;
    boolean numReplaces = false;
    numOffsprings = offspring.size();
    sizePopulation = population.size();
    Vector inserted = new Vector();
    Vector replaced = new Vector();
    
    for (i = 0; i < numOffsprings; i++){
      anOffspring = (Chromosome)offspring.get(i);
      worstChromosomePosition = 0;
      worstFitness = ((Chromosome)(population.get(0))).getCurrentFitness();
      
      for (j = 1; j < sizePopulation; j++){
        aChromosome = (Chromosome)population.get(j);
        double f1 = aChromosome.getCurrentFitness();
        
        if (this.fitnessFunction.compare(worstFitness, f1) > 0){
          worstFitness = f1;
          worstChromosomePosition = j;
        }
      }
      
      double offspringFitness = anOffspring.getCurrentFitness();
      
      if (this.fitnessFunction.compare(offspringFitness, worstFitness) >= 0){
        Chromosome replacedC = (Chromosome)population.get(worstChromosomePosition);
        
        replaced.add(replacedC.clone());
        replacedC.copy(anOffspring);
        inserted.add(anOffspring);
        numReplaces = true;
      }
    }
    
    offspring.removeAll(inserted);
    offspring.addAll(replaced);
    return (numReplaces);
  }
}