/*
 * BestExhaustiveReporter.java
 *
 * Created on 18 de febrero de 2005, 11:53
 */

package geneticalgorithms.Reporters;
import others.UtilFunctions;
import geneticalgorithms.GAStructures.GA;
import geneticalgorithms.GAStructures.SOGA;
import java.io.FileOutputStream;
import java.io.DataOutputStream;

/**
 *
 * @author Carlos
 */
public class BestExhaustiveReporter implements Reporter{
  
  FileOutputStream file;
  DataOutputStream output;
  
  /** Creates a new instance of BestExhaustiveReporter */
  public BestExhaustiveReporter(String filename) {
    
    try{
      file = new FileOutputStream(filename + ".txt");
    } catch(java.io.FileNotFoundException exception){
      throw new java.lang.UnsupportedOperationException("No se puedo abrir el fichero del reporter");
    }
    
    output = new DataOutputStream(file);
  }
  
  public boolean needReport(GA ga){
    return true;
  }
  
  public void report(GA ga){
    
    SOGA soga = (SOGA) ga;
    double bestFitness = soga.getBestFitness();
    long evaluations = soga.getNumEvaluations();
    UtilFunctions.writeForExcel(output, evaluations + "\t" + bestFitness + "\n");
  }
  
  public void close(GA ga){
    
    try{
      output.close();
      file.close();
    } catch (java.io.IOException exception){
      throw new java.lang.UnsupportedOperationException("No se pudo cerrar el fichero del reporter");
    }
  }
}
