/*
 * NumEv_Fitness.java
 *
 * Created on 16 de octubre de 2005, 15:00
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package geneticalgorithms.StopCriterions;
import geneticalgorithms.GAStructures.SOGA;
import FitnessFunctions.FitnessFunction;
import geneticalgorithms.GAStructures.GA;

/**
 *
 * @author carlos
 */
public class NumEv_Fitness implements StopCriterion{
  
  double stopFitness;
  long maxEvaluations;
  FitnessFunction fitnessFunction;
  
  /** Creates a new instance of NumEv_Fitness */
  public NumEv_Fitness(double stopFitness, long maxEvaluations, FitnessFunction fitnessFunction) {
    this.stopFitness = stopFitness;
    this.maxEvaluations = maxEvaluations;
    this.fitnessFunction = fitnessFunction;
  }
  
  /** This functions returns true if the Stop Criterion is true. False in other case. */
  public boolean isTrue(GA ga){
    
    SOGA soga = (SOGA) ga;
    long numEvaluations = ga.getNumEvaluations();
    double bestFitness = soga.getBestFitness();
    return (numEvaluations >= this.maxEvaluations || fitnessFunction.compare(bestFitness, stopFitness) >= 0.);
  }
}
