package others;

/**
 * <p>Título: Genetic Algorithms</p>
 * <p>Descripción: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Empresa: </p>
 * @author Carlos García Martínez
 * @version 1.0
 */

/*******************************************************************/
/*  Rand genera un numero real pseudoaleatorio entre 0 y 1,        */
/*  excluyendo el 1.						   */
/*  Randint genera un numero entero entre low y high, ambos 	   */
/*  incluidos.	   						   */
/*  Randfloat genera un numero real entre low y high, incluido low */
/*  y no incluido high                                             */
/*******************************************************************/

public class Random {
  
  //private static java.util.Random generator = new java.util.Random(123456789);
  private static long MASK = 2147483647;
  private static long PRIME = 65539;
  private static double SCALE = 0.4656612875e-9;
  protected static long Seed = 12345678;
  
  //! Constructor
  public Random(){
    MASK = 2147483647;
    PRIME = 65539;
    SCALE = 0.4656612875e-9;
    Seed = 123456789;
  }
  
  public static void cambiaSemilla(double semillaNueva){
    Seed = (long)semillaNueva;
  }
  
  public static long getSeed(){
    return Seed;
  }
  
  public static double Rand(){
    //return generator.nextDouble();
    //return (Math.random());
    return (( Seed = ( (Seed * PRIME) & MASK) ) * SCALE );
  }
  
  public static int Randint(int low, int high){
    return ( (int) (low + (high-(low)+1) * Rand()));
  }
  
  public static long RandULong(long low, long high){
    return ( (long) (low + (high-(low)+1) * Rand()));
  }
  
  public static double Randfloat(double low, double high){
    return ( (low + (high-(low))*Rand()));
  }
  
  public static int[] RandPerm(int n){
    
    int i, top;
    int[] perm = new int[n];
    top = n - 1;
    
    for (i = 0; i < n; i++)
      perm[i] = i;
    
    for (i = 0; i < n; i++){
      int change = Random.Randint(0, top);
      int aux = perm[change];
      perm[change] = perm[i];
      perm[i] = aux;
    }
    
    return (perm);
  }
}